/***
 * Copyright (c) 2013-2014, Heiko Schäfer <heiko@hgl.rangun.de>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice, this list of conditions and
 * the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
 * and the following disclaimer in the documentation and/or other materials provided with the
 * distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Heiko Schäfer <heiko@hgl.rangun.de> "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Heiko Schäfer <heiko@hgl.rangun.de>
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ***/

#ifndef HGL_TYPE_COLORBASE_H
#define HGL_TYPE_COLORBASE_H

#include <string>

#include <stdint.h>

#include "linkercontrol.h"

namespace HGL {

namespace Type {

/**
 * @author Heiko Schäfer <heiko@hgl.rangun.de>
 **/
class _EXPORT ColorBase {
	DISALLOW_COPY_AND_ASSIGN(ColorBase)
public:
	ColorBase();

	std::string getColorString() const;
	virtual uint32_t getColorInteger() const _PURE;

	virtual void setColor(uint32_t intColor);
	void setColor(const std::string &hexColor);

protected:
	virtual ~ColorBase();

private:
	uint32_t m_colInt;
};

}

}

#endif // HGL_TYPE_COLORBASE_H

// kate: indent-mode cstyle; indent-width 4; replace-tabs off; tab-width 4; 
