/***
 * Copyright (c) 2015, Heiko Schäfer <heiko@hgl.rangun.de>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice, this list of conditions and
 * the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
 * and the following disclaimer in the documentation and/or other materials provided with the
 * distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Heiko Schäfer <heiko@hgl.rangun.de> "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Heiko Schäfer <heiko@hgl.rangun.de>
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 * Generated from 'condition.type' by typecreator.awk - DO NOT MODIFY!
 * Fri Jul 10 04:57:13 UTC 2015
 *
 ***/

#ifndef HGL_TYPECREATOR_AWK_CONDITION_H
#define HGL_TYPECREATOR_AWK_CONDITION_H


#include "conditionbase.h"

namespace HGL {

namespace Type {


class StringParam;
/**
 * @ingroup types
 * @author Heiko Schäfer <heiko@hgl.rangun.de>
 **/
class _EXPORT Condition : public ConditionBase
{
	DISALLOW_COPY_AND_ASSIGN(Condition)
	friend class ProjectFactoryBase;
public:

	using IType::operator=;
	using TypeBase::operator*;

	typedef   ConditionBase base;

	ACCEPT(Condition);

	virtual ~Condition();

	virtual const HGL::Type::SerialID *const *getAllowedTypes() const throw();
	/**
	 * @brief Gets the SerialID of <code>HGL::Type::CONDITION</code>
	 *
	 * @return <code>const HGL::Type::SerialID &CONDITION</code>
	 **/
	virtual const HGL::Type::SerialID &getSerialID() const throw() _CONST;
	virtual operator const Type::StringParam & () const throw(Exception::InvalidExpressionException);
	virtual operator float() const throw(Exception::ReferenceException, Exception::InvalidExpressionException);
	operator bool() const;
	LOGOP getLogOp() const throw() _PURE;
	void setLogOp(LOGOP) throw();
	void setNegate(bool) throw();
	bool getNegate() const throw() _PURE;
	OP getOperator() const throw() _PURE;
	virtual _NOUNUSED IType::Ptr clone() const throw(Exception::CloneNotSupportedException);
	virtual bool operator<(const IType &) const throw(Exception::InvalidExpressionException);
	virtual bool operator==(const IType &) const throw(Exception::InvalidExpressionException);

protected:
	explicit Condition(const OP &);

	virtual const IType *obtainControlSourceParameter(uint32_t csp, const SerialID &sid) const;

private:
	OP m_op;
	LOGOP m_logop;
	bool m_negate;
	StringParam *const m_toSP;
};

}

template<> inline _HOT IType::Ptr::operator Type::Condition *() const throw() {
	return reinterpret_cast<Type::Condition *>(m_ptr);
}

extern template HGL::IType::Ptr::operator HGL::Type::Condition *() const throw();

}

#endif // HGL_TYPECREATOR_AWK_CONDITION_H
