/***
 * Copyright (c) 2015, Heiko Schäfer <heiko@hgl.rangun.de>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice, this list of conditions and
 * the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
 * and the following disclaimer in the documentation and/or other materials provided with the
 * distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Heiko Schäfer <heiko@hgl.rangun.de> "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Heiko Schäfer <heiko@hgl.rangun.de>
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 * Generated from 'ellipse.type' by typecreator.awk - DO NOT MODIFY!
 * Fri Jul 10 04:57:13 UTC 2015
 *
 ***/

#ifndef HGL_TYPECREATOR_AWK_ELLIPSE_H
#define HGL_TYPECREATOR_AWK_ELLIPSE_H


#include "proxy.h"
#include "nonemptytype.h"
#include "ifillable.h"


namespace HGL {

namespace Type {


class IPoint;
class Fill;
/**
 * @ingroup types
 * @author Heiko Schäfer <heiko@hgl.rangun.de>
 **/
class _EXPORT Ellipse : public Utility::Proxy<Ellipse, NonEmptyType>
, public virtual IFillable
{
	DISALLOW_COPY_AND_ASSIGN(Ellipse)
	friend class ProjectFactoryBase;
public:

	using IType::operator=;
	using TypeBase::operator*;

	typedef  Utility::Proxy<Ellipse,  NonEmptyType> base;

	using TypeBase::attachType;
	ACCEPT(Ellipse);

	virtual ~Ellipse();

	virtual const HGL::Type::SerialID *const *getAllowedTypes() const throw();
	/**
	 * @brief Gets the SerialID of <code>HGL::Type::ELLIPSE</code>
	 *
	 * @return <code>const HGL::Type::SerialID &ELLIPSE</code>
	 **/
	virtual const HGL::Type::SerialID &getSerialID() const throw() _CONST;
	const IPoint *getPoint() const throw();
	const Fill *getFill() const throw();
	BaseVector2D *getRadius() const;
	virtual bool isValid() const throw();
	virtual BOUNDINGBOX getBoundingBox() const;
	virtual Ellipse *operator+(const IType &) throw(Exception::ReferenceException, Exception::InvalidExpressionException);
	_NOUNUSED virtual const TYPELIST &getAttachedTypes() const throw();

protected:
	explicit Ellipse();

	virtual IType *attachType(IType *type, const HGL::IType::TYPELIST::iterator &before, bool check) throw(Exception::AttachException);

private:
};

extern template class Utility::Proxy<Ellipse, NonEmptyType>;

}

template<> inline _HOT IType::Ptr::operator Type::Ellipse *() const throw() {
	return reinterpret_cast<Type::Ellipse *>(m_ptr);
}

extern template HGL::IType::Ptr::operator HGL::Type::Ellipse *() const throw();

}

#endif // HGL_TYPECREATOR_AWK_ELLIPSE_H
