/***
 * Copyright (c) 2015, Heiko Schäfer <heiko@hgl.rangun.de>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice, this list of conditions and
 * the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
 * and the following disclaimer in the documentation and/or other materials provided with the
 * distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Heiko Schäfer <heiko@hgl.rangun.de> "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Heiko Schäfer <heiko@hgl.rangun.de>
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 * Generated from 'fill.type' by typecreator.awk - DO NOT MODIFY!
 * Fri Jul 10 04:57:13 UTC 2015
 *
 ***/

#ifndef HGL_TYPECREATOR_AWK_FILL_H
#define HGL_TYPECREATOR_AWK_FILL_H


#include "proxy.h"

namespace HGL {

namespace Type {


/**
 * @ingroup types
 * @author Heiko Schäfer <heiko@hgl.rangun.de>
 **/
class _EXPORT Fill : public Utility::Proxy<Fill>
{
	DISALLOW_COPY_AND_ASSIGN(Fill)
	friend class ProjectFactoryBase;
public:

	using IType::operator=;
	using TypeBase::operator*;

	typedef   Utility::Proxy<Fill> base;

	ACCEPT(Fill);

	virtual ~Fill();

	virtual const HGL::Type::SerialID *const *getAllowedTypes() const throw();
	/**
	 * @brief Gets the SerialID of <code>HGL::Type::FILL</code>
	 *
	 * @return <code>const HGL::Type::SerialID &FILL</code>
	 **/
	virtual const HGL::Type::SerialID &getSerialID() const throw() _CONST;
	uint32_t getColor1() const throw();
	std::string getColorString1() const;
	void setColor1(uint32_t intCol) throw();
	void setColor1(const std::string &hexColor) throw(Exception::InvalidExpressionException);
	uint32_t getColor2() const throw();
	std::string getColorString2() const;
	void setColor2(uint32_t intCol) throw();
	void setColor2(const std::string &hexColor) throw(Exception::InvalidExpressionException);
	void setCentric(bool) throw();
	bool isCentric() const throw();
	virtual BOUNDINGBOX getBoundingBox() const;
	virtual Fill * operator+(const IType &) throw(Exception::ReferenceException, Exception::InvalidExpressionException) _CONST;
	virtual Fill *operator*(const IType &) throw(Exception::ReferenceException, Exception::InvalidExpressionException) _CONST;
	virtual Fill *operator*(const float *) throw(Exception::ReferenceException, Exception::InvalidExpressionException) _CONST;

protected:
	explicit Fill();

	void setSecondCol(bool) throw();
	bool hasSecondCol() const throw();

private:
	uint32_t m_color1;
	uint32_t m_color2;
	bool m_centric;
	bool m_secondCol;
};

template<> struct IReferenceHolder::PropertyTraits<Fill> {
	typedef Fill type;
	bool operator()(const type *t, const type *op) const throw();
};

extern template bool IReferenceHolder::isPropertyEqual<Fill>(const IReferenceHolder::PropertyTraits<Fill>::type *) const throw();

extern template class Utility::Proxy<Fill>;

}

template<> inline _HOT IType::Ptr::operator Type::Fill *() const throw() {
	return reinterpret_cast<Type::Fill *>(m_ptr);
}

extern template HGL::IType::Ptr::operator HGL::Type::Fill *() const throw();

}

#endif // HGL_TYPECREATOR_AWK_FILL_H
