/***
 * Copyright (c) 2015, Heiko Schäfer <heiko@hgl.rangun.de>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice, this list of conditions and
 * the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
 * and the following disclaimer in the documentation and/or other materials provided with the
 * distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Heiko Schäfer <heiko@hgl.rangun.de> "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Heiko Schäfer <heiko@hgl.rangun.de>
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 * Generated automatically by genITypeVisitor.awk - DO NOT MODIFY!
 *
 **/

#ifndef HGL_ITYPEVISITOR_H
#define HGL_ITYPEVISITOR_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "linkercontrol.h"

namespace HGL {

namespace Type {

class AssignmentOperator;
class Comment;
class Curve;
class Condition;
class ConditionBlock;
class DebugProcedure;
class Ellipse;
class Fill;
class IfElse;
class Include;
class MainSegment;
class NamedParam;
class ObjectsSegment;
class ParamSection;
class Pen;
class Poly;
class ProcCall;
class ProceduresSegment;
class ProcInitStatement;
class RenderCallback;
class RenderProcedure;
class Signature;
class StdLibCall;
class VirtualGroup;
class ExpressionParam;
class FloatParam;
class Line;
class Point;
class Procedure;
class Project;
class ReferenceParam;
class StringParam;
class Text;
class Vector2D;
class NullType;
class NullLine;

/**
 * @interface ITypeVisitor
 * @brief Base class of all visitors.
 *
 * This class provides empty implementations for all types to use in visitors
 *
 * @author Heiko Schäfer <heiko@hgl.rangun.de>
 **/
class _PACKED _INTERNAL ITypeVisitor {
	DISALLOW_COPY_AND_ASSIGN(ITypeVisitor)
public:
	inline virtual ~ITypeVisitor() {}
	/**
	 * @brief visits <code>HGL::Type::AssignmentOperator</code>
	 * @param HGL::Type::AssignmentOperator visited node
	 **/
	inline virtual void visit(HGL::Type::AssignmentOperator *) _NONNULL(2) {} // extracted from ''
	/**
	 * @brief visits <code>HGL::Type::Comment</code>
	 * @param HGL::Type::Comment visited node
	 **/
	inline virtual void visit(HGL::Type::Comment *) _NONNULL(2) {} // extracted from 'comment.h'
	/**
	 * @brief visits <code>HGL::Type::Curve</code>
	 * @param HGL::Type::Curve visited node
	 **/
	inline virtual void visit(HGL::Type::Curve *) _NONNULL(2) {} // extracted from 'curve.h'
	/**
	 * @brief visits <code>HGL::Type::Condition</code>
	 * @param HGL::Type::Condition visited node
	 **/
	inline virtual void visit(HGL::Type::Condition *) _NONNULL(2) {} // extracted from 'condition.h'
	/**
	 * @brief visits <code>HGL::Type::ConditionBlock</code>
	 * @param HGL::Type::ConditionBlock visited node
	 **/
	inline virtual void visit(HGL::Type::ConditionBlock *) _NONNULL(2) {} // extracted from 'conditionblock.h'
	/**
	 * @brief visits <code>HGL::Type::DebugProcedure</code>
	 * @param HGL::Type::DebugProcedure visited node
	 **/
	inline virtual void visit(HGL::Type::DebugProcedure *) _NONNULL(2) {} // extracted from 'debugprocedure.h'
	/**
	 * @brief visits <code>HGL::Type::Ellipse</code>
	 * @param HGL::Type::Ellipse visited node
	 **/
	inline virtual void visit(HGL::Type::Ellipse *) _NONNULL(2) {} // extracted from 'ellipse.h'
	/**
	 * @brief visits <code>HGL::Type::Fill</code>
	 * @param HGL::Type::Fill visited node
	 **/
	inline virtual void visit(HGL::Type::Fill *) _NONNULL(2) {} // extracted from 'fill.h'
	/**
	 * @brief visits <code>HGL::Type::IfElse</code>
	 * @param HGL::Type::IfElse visited node
	 **/
	inline virtual void visit(HGL::Type::IfElse *) _NONNULL(2) {} // extracted from 'ifelse.h'
	/**
	 * @brief visits <code>HGL::Type::Include</code>
	 * @param HGL::Type::Include visited node
	 **/
	inline virtual void visit(HGL::Type::Include *) _NONNULL(2) {} // extracted from 'include.h'
	/**
	 * @brief visits <code>HGL::Type::MainSegment</code>
	 * @param HGL::Type::MainSegment visited node
	 **/
	inline virtual void visit(HGL::Type::MainSegment *) _NONNULL(2) {} // extracted from 'mainsegment.h'
	/**
	 * @brief visits <code>HGL::Type::NamedParam</code>
	 * @param HGL::Type::NamedParam visited node
	 **/
	inline virtual void visit(HGL::Type::NamedParam *) _NONNULL(2) {} // extracted from 'namedparam.h'
	/**
	 * @brief visits <code>HGL::Type::ObjectsSegment</code>
	 * @param HGL::Type::ObjectsSegment visited node
	 **/
	inline virtual void visit(HGL::Type::ObjectsSegment *) _NONNULL(2) {} // extracted from 'objectssegment.h'
	/**
	 * @brief visits <code>HGL::Type::ParamSection</code>
	 * @param HGL::Type::ParamSection visited node
	 **/
	inline virtual void visit(HGL::Type::ParamSection *) _NONNULL(2) {} // extracted from 'paramsection.h'
	/**
	 * @brief visits <code>HGL::Type::Pen</code>
	 * @param HGL::Type::Pen visited node
	 **/
	inline virtual void visit(HGL::Type::Pen *) _NONNULL(2) {} // extracted from 'pen.h'
	/**
	 * @brief visits <code>HGL::Type::Poly</code>
	 * @param HGL::Type::Poly visited node
	 **/
	inline virtual void visit(HGL::Type::Poly *) _NONNULL(2) {} // extracted from 'poly.h'
	/**
	 * @brief visits <code>HGL::Type::ProcCall</code>
	 * @param HGL::Type::ProcCall visited node
	 **/
	inline virtual void visit(HGL::Type::ProcCall *) _NONNULL(2) {} // extracted from 'proccall.h'
	/**
	 * @brief visits <code>HGL::Type::ProceduresSegment</code>
	 * @param HGL::Type::ProceduresSegment visited node
	 **/
	inline virtual void visit(HGL::Type::ProceduresSegment *) _NONNULL(2) {} // extracted from 'proceduressegment.h'
	/**
	 * @brief visits <code>HGL::Type::ProcInitStatement</code>
	 * @param HGL::Type::ProcInitStatement visited node
	 **/
	inline virtual void visit(HGL::Type::ProcInitStatement *) _NONNULL(2) {} // extracted from 'procinitstatement.h'
	/**
	 * @brief visits <code>HGL::Type::RenderCallback</code>
	 * @param HGL::Type::RenderCallback visited node
	 **/
	inline virtual void visit(HGL::Type::RenderCallback *) _NONNULL(2) {} // extracted from 'rendercallback.h'
	/**
	 * @brief visits <code>HGL::Type::RenderProcedure</code>
	 * @param HGL::Type::RenderProcedure visited node
	 **/
	inline virtual void visit(HGL::Type::RenderProcedure *) _NONNULL(2) {} // extracted from 'renderprocedure.h'
	/**
	 * @brief visits <code>HGL::Type::Signature</code>
	 * @param HGL::Type::Signature visited node
	 **/
	inline virtual void visit(HGL::Type::Signature *) _NONNULL(2) {} // extracted from 'signature.h'
	/**
	 * @brief visits <code>HGL::Type::StdLibCall</code>
	 * @param HGL::Type::StdLibCall visited node
	 **/
	inline virtual void visit(HGL::Type::StdLibCall *) _NONNULL(2) {} // extracted from 'stdlibcall.h'
	/**
	 * @brief visits <code>HGL::Type::VirtualGroup</code>
	 * @param HGL::Type::VirtualGroup visited node
	 **/
	inline virtual void visit(HGL::Type::VirtualGroup *) _NONNULL(2) {} // extracted from 'virtualgroup.h'
	/**
	 * @brief visits <code>HGL::Type::ExpressionParam</code>
	 * @param HGL::Type::ExpressionParam visited node
	 **/
	inline virtual void visit(HGL::Type::ExpressionParam *) _NONNULL(2) {} // extracted from 'include/expressionparam.h'
	/**
	 * @brief visits <code>HGL::Type::FloatParam</code>
	 * @param HGL::Type::FloatParam visited node
	 **/
	inline virtual void visit(HGL::Type::FloatParam *) _NONNULL(2) {} // extracted from 'include/floatparam.h'
	/**
	 * @brief visits <code>HGL::Type::Line</code>
	 * @param HGL::Type::Line visited node
	 **/
	inline virtual void visit(HGL::Type::Line *) _NONNULL(2) {} // extracted from 'include/line.h'
	/**
	 * @brief visits <code>HGL::Type::Point</code>
	 * @param HGL::Type::Point visited node
	 **/
	inline virtual void visit(HGL::Type::Point *) _NONNULL(2) {} // extracted from 'include/point.h'
	/**
	 * @brief visits <code>HGL::Type::Procedure</code>
	 * @param HGL::Type::Procedure visited node
	 **/
	inline virtual void visit(HGL::Type::Procedure *) _NONNULL(2) {} // extracted from 'include/procedure.h'
	/**
	 * @brief visits <code>HGL::Type::Project</code>
	 * @param HGL::Type::Project visited node
	 **/
	inline virtual void visit(HGL::Type::Project *) _NONNULL(2) {} // extracted from 'include/project.h'
	/**
	 * @brief visits <code>HGL::Type::ReferenceParam</code>
	 * @param HGL::Type::ReferenceParam visited node
	 **/
	inline virtual void visit(HGL::Type::ReferenceParam *) _NONNULL(2) {} // extracted from 'include/referenceparam.h'
	/**
	 * @brief visits <code>HGL::Type::StringParam</code>
	 * @param HGL::Type::StringParam visited node
	 **/
	inline virtual void visit(HGL::Type::StringParam *) _NONNULL(2) {} // extracted from 'include/stringparam.h'
	/**
	 * @brief visits <code>HGL::Type::Text</code>
	 * @param HGL::Type::Text visited node
	 **/
	inline virtual void visit(HGL::Type::Text *) _NONNULL(2) {} // extracted from 'include/text.h'
	/**
	 * @brief visits <code>HGL::Type::Vector2D</code>
	 * @param HGL::Type::Vector2D visited node
	 **/
	inline virtual void visit(HGL::Type::Vector2D *) _NONNULL(2) {} // extracted from 'include/vector2d.h'
	/**
	 * @brief visits <code>HGL::Type::NullType</code>
	 * @param HGL::Type::NullType visited node
	 **/
	inline virtual void visit(HGL::Type::NullType *) _NONNULL(2) {} // extracted from 'nulltype.h'
	/**
	 * @brief visits <code>HGL::Type::NullLine</code>
	 * @param HGL::Type::NullLine visited node
	 **/
	inline virtual void visit(HGL::Type::NullLine *) _NONNULL(2) {} // extracted from 'nulltype.h'

protected:
	inline ITypeVisitor() {}
};

}

}

#endif // HGL_ITYPEVISITOR_H
