/***
 * Copyright (c) 2015, Heiko Schäfer <heiko@hgl.rangun.de>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice, this list of conditions and
 * the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
 * and the following disclaimer in the documentation and/or other materials provided with the
 * distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Heiko Schäfer <heiko@hgl.rangun.de> "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Heiko Schäfer <heiko@hgl.rangun.de>
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 * Generated from 'namedparam.type' by typecreator.awk - DO NOT MODIFY!
 * Fri Jul 10 04:57:13 UTC 2015
 *
 ***/

#ifndef HGL_TYPECREATOR_AWK_NAMEDPARAM_H
#define HGL_TYPECREATOR_AWK_NAMEDPARAM_H


#include "referenceparam.h"

namespace HGL {

namespace Type {


class ExpressionParam;
/**
 * @ingroup types
 * @author Heiko Schäfer <heiko@hgl.rangun.de>
 **/
class _EXPORT NamedParam : public ReferenceParam
{
	DISALLOW_COPY_AND_ASSIGN(NamedParam)
	friend class ProjectFactoryBase;
public:

	using IType::operator=;
	using TypeBase::operator*;

	typedef   ReferenceParam base;

	using ReferenceParam::findReference;
	ACCEPT(NamedParam);

	virtual ~NamedParam();

	virtual const HGL::Type::SerialID *const *getAllowedTypes() const throw();
	/**
	 * @brief Gets the SerialID of <code>HGL::Type::NAMEDPARAM</code>
	 *
	 * @return <code>const HGL::Type::SerialID &NAMEDPARAM</code>
	 **/
	virtual const HGL::Type::SerialID &getSerialID() const throw() _CONST;
	virtual const std::string &getId() const _CONST;
	StringParam *getCallProc() const;
	_NOUNUSED virtual const IType *findReference(bool recache = false) const;

protected:
	explicit NamedParam(const std::string &typeName);

	virtual operator StringParam&() const throw(Exception::InvalidExpressionException);
	virtual std::string getTypeName() const throw();
	virtual const IType *obtainControlSourceParameter(uint32_t csp) const;

private:
};

}

template<> inline _HOT IType::Ptr::operator Type::NamedParam *() const throw() {
	return reinterpret_cast<Type::NamedParam *>(m_ptr);
}

extern template HGL::IType::Ptr::operator HGL::Type::NamedParam *() const throw();

}

#endif // HGL_TYPECREATOR_AWK_NAMEDPARAM_H
