/***
 * Copyright (c) 2012-2014, Heiko Schäfer <heiko@hgl.rangun.de>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice, this list of conditions and
 * the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
 * and the following disclaimer in the documentation and/or other materials provided with the
 * distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Heiko Schäfer <heiko@hgl.rangun.de> "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Heiko Schäfer <heiko@hgl.rangun.de>
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ***/

#ifndef HGL_PLUGININFOBASE_H
#define HGL_PLUGININFOBASE_H

#ifdef WIN32
#include <windows.h>
#undef RGB
#endif

namespace HGL {

namespace Common {

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Weffc++"
struct __attribute__((__packed__)) _pluginInfoBase {
#ifndef WIN32
	inline _pluginInfoBase(void *phandle, const wchar_t *pname, const wchar_t *pauthor,
						   const wchar_t *pcopyright, const wchar_t *pdescription)
#else
	inline _pluginInfoBase(HINSTANCE phandle, const wchar_t *pname, const wchar_t *pauthor,
						   const wchar_t *pcopyright, const wchar_t *pdescription)
#endif
		: handle(phandle), name(pname), author(pauthor), copyright(pcopyright),
		description(pdescription) {}

#ifndef WIN32
void *handle;
#else
HINSTANCE handle;
#endif
const wchar_t *name;
const wchar_t *author;
const wchar_t *copyright;
const wchar_t *description;
};
#pragma GCC diagnostic pop

}

}

#endif // HGL_PLUGININFOBASE_H

// kate: indent-mode cstyle; indent-width 4; replace-tabs off; tab-width 4; 
