/***
 * Copyright (c) 2015, Heiko Schäfer <heiko@hgl.rangun.de>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice, this list of conditions and
 * the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
 * and the following disclaimer in the documentation and/or other materials provided with the
 * distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Heiko Schäfer <heiko@hgl.rangun.de> "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Heiko Schäfer <heiko@hgl.rangun.de>
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 * Generated from 'poly.type' by typecreator.awk - DO NOT MODIFY!
 * Fri Jul 10 04:57:13 UTC 2015
 *
 ***/

#ifndef HGL_TYPECREATOR_AWK_POLY_H
#define HGL_TYPECREATOR_AWK_POLY_H


#include "proxy.h"
#include "ifillable.h"


namespace HGL {

namespace Type {


class Fill;
/**
 * @ingroup types
 * @author Heiko Schäfer <heiko@hgl.rangun.de>
 **/
class _EXPORT Poly : public Utility::Proxy<Poly>
, public virtual IFillable
{
	DISALLOW_COPY_AND_ASSIGN(Poly)
	friend class ProjectFactoryBase;
public:

	using IType::operator=;
	using TypeBase::operator*;

	typedef   Utility::Proxy<Poly> base;

	using TypeBase::attachType;
	using TypeBase::getAttachedTypes;
	ACCEPT(Poly);

	virtual ~Poly();

	virtual const HGL::Type::SerialID *const *getAllowedTypes() const throw();
	/**
	 * @brief Gets the SerialID of <code>HGL::Type::POLY</code>
	 *
	 * @return <code>const HGL::Type::SerialID &POLY</code>
	 **/
	virtual const HGL::Type::SerialID &getSerialID() const throw() _CONST;
	_NOUNUSED virtual const TYPELIST &getAttachedTypes() const throw();
	const Fill *getFill() const throw();
	virtual BOUNDINGBOX getBoundingBox() const;
	virtual bool isValid() const throw();
	void reorder(const std::vector<HGL::IType::TYPELIST::difference_type>& rv);
	virtual Poly *operator+(const IType &) throw(Exception::ReferenceException, Exception::InvalidExpressionException);
	virtual Poly *operator*(const IType &) throw(Exception::ReferenceException, Exception::InvalidExpressionException);
	virtual Poly *operator*(const float *) throw(Exception::ReferenceException, Exception::InvalidExpressionException);

protected:
	explicit Poly();

	explicit Poly(const SerialID &sid);
	virtual IType *attachType(IType *type, const HGL::IType::TYPELIST::iterator &before, bool check) throw(Exception::AttachException);
	virtual void detachType(IType *type);

private:
	mutable bool m_noValidityCheckNeeded;
	bool m_fillIsAttached;
};

extern template class Utility::Proxy<Poly>;

}

template<> inline _HOT IType::Ptr::operator Type::Poly *() const throw() {
	return reinterpret_cast<Type::Poly *>(m_ptr);
}

extern template HGL::IType::Ptr::operator HGL::Type::Poly *() const throw();

}

#endif // HGL_TYPECREATOR_AWK_POLY_H
