/***
 * Copyright (c) 2015, Heiko Schäfer <heiko@hgl.rangun.de>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice, this list of conditions and
 * the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
 * and the following disclaimer in the documentation and/or other materials provided with the
 * distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Heiko Schäfer <heiko@hgl.rangun.de> "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Heiko Schäfer <heiko@hgl.rangun.de>
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 * Generated from 'proccall.type' by typecreator.awk - DO NOT MODIFY!
 * Fri Jul 10 04:57:13 UTC 2015
 *
 ***/

#ifndef HGL_TYPECREATOR_AWK_PROCCALL_H
#define HGL_TYPECREATOR_AWK_PROCCALL_H


#include "referenceholderbase.h"

namespace HGL {

namespace Type {


class ParamSection;
class ParamHolder;
/**
 * @ingroup types
 * @author Heiko Schäfer <heiko@hgl.rangun.de>
 **/
class _EXPORT ProcCall : public virtual ReferenceHolderBase<TypeBase>
{
	DISALLOW_COPY_AND_ASSIGN(ProcCall)
	friend class ProjectFactoryBase;
public:

	using IType::operator=;
	using TypeBase::operator*;

	typedef    ReferenceHolderBase<TypeBase> base;

	typedef std::stack<const HGL::Type::ParamHolder *> FRAMESTACK;
	ACCEPT(ProcCall);

	virtual ~ProcCall();

	virtual const HGL::Type::SerialID *const *getAllowedTypes() const throw();
	/**
	 * @brief Gets the SerialID of <code>HGL::Type::PROCCALL</code>
	 *
	 * @return <code>const HGL::Type::SerialID &PROCCALL</code>
	 **/
	virtual const HGL::Type::SerialID &getSerialID() const throw() _CONST;
	bool assignParameters(const FRAMESTACK * const = 0L) const;
	void withdrawParameters() const;

protected:
	explicit ProcCall(IType *lib = 0L);


private:
	mutable IType::TYPELIST m_origRefs;
};

extern template class ReferenceHolderBase<TypeBase>;

}

template<> inline _HOT IType::Ptr::operator Type::ProcCall *() const throw() {
	return reinterpret_cast<Type::ProcCall *>(m_ptr);
}

extern template HGL::IType::Ptr::operator HGL::Type::ProcCall *() const throw();

}

#endif // HGL_TYPECREATOR_AWK_PROCCALL_H
