/***
 * Copyright (c) 2015, Heiko Schäfer <heiko@hgl.rangun.de>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice, this list of conditions and
 * the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
 * and the following disclaimer in the documentation and/or other materials provided with the
 * distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Heiko Schäfer <heiko@hgl.rangun.de> "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Heiko Schäfer <heiko@hgl.rangun.de>
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 * Generated from 'stdlibcall.type' by typecreator.awk - DO NOT MODIFY!
 * Fri Jul 10 04:57:13 UTC 2015
 *
 ***/

#ifndef HGL_TYPECREATOR_AWK_STDLIBCALL_H
#define HGL_TYPECREATOR_AWK_STDLIBCALL_H


#include "itypevisitor.h"
#include "serialid.h"

#include "proccall.h"

namespace HGL {

namespace Type {


/**
 * @ingroup types
 * @author Heiko Schäfer <heiko@hgl.rangun.de>
 **/
class _EXPORT StdLibCall : public ProcCall
{
	DISALLOW_COPY_AND_ASSIGN(StdLibCall)
	friend class ProjectFactoryBase;
public:

	using IType::operator=;
	using TypeBase::operator*;

	typedef   ProcCall base;

	inline ACCEPT(StdLibCall);


	virtual ~StdLibCall();

	virtual const HGL::Type::SerialID *const *getAllowedTypes() const throw();
	/**
	 * @brief Gets the SerialID of <code>HGL::Type::STDLIBCALL</code>
	 *
	 * @return <code>const HGL::Type::SerialID &STDLIBCALL</code>
	 **/
	_CONST inline virtual const HGL::Type::SerialID &getSerialID() const throw() {
		return HGL::Type::SerialID::STDLIBCALL;
	}

protected:
	inline explicit StdLibCall(IType *lib) : ProcCall(lib) {}


private:
};

ACCEPT_IMPL(StdLibCall)

}

template<> inline _HOT IType::Ptr::operator Type::StdLibCall *() const throw() {
	return reinterpret_cast<Type::StdLibCall *>(m_ptr);
}

extern template HGL::IType::Ptr::operator HGL::Type::StdLibCall *() const throw();

}

#endif // HGL_TYPECREATOR_AWK_STDLIBCALL_H
